import java.util.Arrays;

/**
 * Created by leon on 1/29/18.
 */
public class StringArrayUtils {
    
    /**
     * @param array array of String objects
     * @return first element of specified array
     */ // TODO
    public static String getFirstElement(String[] array) {
        return array[0];
    }

    /**
     * @param array array of String objects
     * @return second element in specified array
     */
    public static String getSecondElement(String[] array) {
        return array[1];
    }

    /**
     * @param array array of String objects
     * @return last element in specified array
     */ // TODO
    public static String getLastElement(String[] array) {
        return array[array.length-1];
    }

    /**
     * @param array array of String objects
     * @return second to last element in specified array
     */ // TODO
    public static String getSecondToLastElement(String[] array) {
        return array[array.length-2];
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return true if the array contains the specified `value`
     */ // TODO
    public static boolean contains(String[] array, String value) {
        for(int i = 0; i < array.length; i++) {
            if(array[i].equals(value)) return true;
        }
        return false;
    }

    /**
     * @param array of String objects
     * @return an array with identical contents in reverse order
     */ // TODO
    public static String[] reverse(String[] array) {
        String[] revArray = new String[array.length];
        for (int i = 0; i < array.length; i++) {
            revArray[i] = array[array.length - 1 - i];
        }
        return revArray;
    }

    /**
     * @param array array of String objects
     * @return true if the order of the array is the same backwards and forwards
     */ // TODO
    public static boolean isPalindromic(String[] array) {

        for ( int i = 0; i < array.length / 2; i++) {
            if (array[i] != array[array.length - 1 - i]) {
                return false;
            }
        }    
        return true;
    }

    /**
     * @param array array of String objects
     * @return true if each letter in the alphabet has been used in the array
     */ // TODO
    public static boolean isPangramic(String[] array) {
        //boolean result= true;
        String words = String.join("", array).toLowerCase();

      int counterTrue = 0;
        for(char c = 'a';c <= 'z'; c++) {

            if(words.contains(String.valueOf(c))) {
                //result = false;
                counterTrue++;
                //return true;
            } 
        }

        if (counterTrue == 26) return true;
        return false;
    }
        
    

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return number of occurrences the specified `value` has occurred
     */ // TODO

    public static int getNumberOfOccurrences(String[] array, String value) {
        int num = 0;
        for (int i=0;i<array.length;i++){
            if (array[i]== value){
                num++;
            }

        }

        return num;
    }

    /**
     * @param array         array of String objects
     * @param valueToRemove value to remove from array
     * @return array with identical contents excluding values of `value`
     */ // TODO
    public static String[] removeValue(String[] array, String valueToRemove) {
        int newLength = array.length;
        String[] result = new String[array.length-1];
        String[] removedValue = new String[1];
        int count1 = 0; // count tracks the current index of the output array
        int count2 = 0; // count tracks the current index of the output array
        
        for(int i = 0; i < array.length; i++) // i tracks the current index of the input array
        {
            if(!array[i].contains(valueToRemove)) {
                result[count1] = array[i]; 
                count1++;
            }else {
                removedValue[count2] = array[i];
                count2++;
            }
        }
        return result;
    }

    /**
     * @param array array of chars
     * @return array of Strings with consecutive duplicates removes
     */ // TODO
    public static String[] removeConsecutiveDuplicates(String[] array) {
        String[] resultArray = new String[array.length];
        int resultIndex = 0;
        for(int i = 0; i < array.length; i++) {
            
            if(i == 0) {
                resultArray[resultIndex] = array[i];
                resultIndex++;
            }
            else if((i > 0 && i < array.length-2) && (!array[i].equals(array[i-1]) || !array[i].equals(array[i+1])))
            {
                resultArray[resultIndex] = array[i];
                resultIndex++;
            }else if (i == array.length-1 && !array[i].equals(array[i-1])) {
                resultArray[resultIndex] = array[i];
                resultIndex++;
            }
        }
        String[] realAnswer = Arrays.copyOf(resultArray, resultIndex);
        return realAnswer;
    }

    /**
     * @param array array of chars
     * @return array of Strings with each consecutive duplicate occurrence concatenated as a single string in an array of Strings
     */ // TODO
    public static String[] packConsecutiveDuplicates(String[] array) {
        String[] resultArray = new String[array.length];
        StringBuilder dups = new StringBuilder();
        int resultIndex = 0;
        for(int i = 0; i < array.length; i++) {
            
            if(i == 0) {
                resultArray[resultIndex] = array[i];
                dups.append(array[i].toString());
                resultIndex++;
            }
            else if((i > 0 && i < array.length-2) && (array[i].equals(array[i-1]) || array[i].equals(array[i+1])))
            {
                resultArray[resultIndex] = array[i];
                dups.append(array[i].toString());
                resultIndex++;
            }else if (i == array.length-1 && array[i].equals(array[i-1])) {
                resultArray[resultIndex] = array[i];
                dups.append(array[i].toString());
                resultIndex++;
            }
        }
        String[] realAnswer = Arrays.copyOf(resultArray, resultIndex);
        return realAnswer;
    }

}
